<?php
//This uses the authenticated Twitter API and an unauthed Twitter Search wrapper to reduce the number of calls used
include('twitter.php');
include('search.php');
include('database.php');
include('geohash.class.php');


$result = db_query("SELECT statusid FROM weather ORDER BY statusid DESC LIMIT 1");
$row = db_fetch_array($result);
$latest = $row['statusid'];
$twitter = new Twitter('your.twitter.username','your.twitter.password');

function cURLXML($url) {
  $options[CURLOPT_URL] = $url;
  $options[CURLOPT_PORT] = 80;
  $options[CURLOPT_FOLLOWLOCATION] = true;
  $options[CURLOPT_RETURNTRANSFER] = true;
	$curl = curl_init();
	curl_setopt_array($curl, $options);
	$response = curl_exec($curl);
	$headers = curl_getinfo($curl);
	$errorNumber = curl_errno($curl);
	$errorMessage = curl_error($curl);
	curl_close($curl);
	$xml = @simplexml_load_string($response);
  return $xml;
}

function latlng2GH($lat,$lng) {
  $geohash=new Geohash();
  return $geohash->encodeGeohash($lat, $lng);
}

$weatherwords = array(
  'rain' => array(
    'rain',
    'regen',
    'illuvia',
    'pleu',
    '雨',
    'дождь',
    '下雨',
    'regnvejr',
    'βροχή',
    'rigning',
    ),
  'snow' => array(
    'snow',
    'schnee',
    'nieve',
    'niege',
    '雪',
    'Snjór',
    'снег',
    'χιόνι',
    ),
  'hailstone' => array(
    'hailstone',
    'hagel',
    'granizo',
    'grêle',
    '雹',
    'χαλαζόκοκκος',
    'градина',
    ),
  'thunder' => array(
    'thunder',
    'donner',
    'truenos',
    'tonner',
    '雷',
    ),
  'lightning' => array(
    'lightning',
    'blitz',
    'rayo',
    'foudre',
    '雷',
    '闪电',
    'Молния',
    'αστραπή',
    ),
  'sunny' => array(
    'sunny',
    'sonnig',
    'soleado',
    'ensoleillé',
    '日当たり',
    ),
  'blizzard' => array(
    'blizzard',
    'scnheesturm',
    '吹雪',
    ),
    );




    
    foreach($weatherwords as $word=>$translations) {
      foreach($translations as $searchterm) {
      	$twitter_query= $searchterm;
      	$search = new TwitterSearch($twitter_query);
      	$search->since($latest);
      	$results = $search->results();

        // $results = array_slice($results,0,10); //Useful for testing
      	foreach($results as $result){
          //Username
      	  $user = $result->from_user;
      	  $id = $result->id;
      	  
      	  $result = db_query("SELECT * FROM weather WHERE username='$user'");
      	  if(db_num_rows($result)>0) {
        	  $row = db_fetch_array($result);
            $lat = $row['lat'];
            $lng = $row['long'];
      	  } else {
            $userdetail = $twitter->getUser($user);
        	  $xml = cURLXML("http://maps.google.com/maps/geo?q=".urlencode($userdetail['location'])."&output=xml");
        		$coor =  $xml->Response->Placemark->Point->coordinates;
            $latlng = explode(',',$coor);
            $lng=$latlng[0];
            $lat=$latlng[1];
      	  }
          
          
          //Geohash
          $gt = latlng2GH($lat,$lng);
          
          if($lat!='') {
            if(db_count("SELECT COUNT(*) AS count FROM weather WHERE statusid='$id'")==0) {
              db_query("INSERT INTO weather VALUES ('$user', '$id', NOW(), '$lat', '$lng', '$gt', '$word')");
            }
          }
      	}
      }
    }
    //Keep results fresh (ish)
    db_query("DELETE FROM weather WHERE time < DATE_SUB(NOW(), INTERVAL 6 HOUR)");
    
    
    
?>